blob: 816f39d2cd40a61df2f08e02026dd17c3487133a [file] [log] [blame]
garciadeblas93c61312016-09-28 15:12:48 +02001#!/bin/bash
garciadeblas38d91ee2019-11-07 16:31:23 +01002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
14#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian
garciadeblasf407c452024-08-22 14:23:40 +020016RELEASE=ReleaseSIXTEEN
garciadeblas7bcadc52020-02-02 22:40:15 +010017REPOSITORY=stable
garciadeblas931a5122023-10-03 17:52:02 +020018DOCKER_TAG="testing-daily"
garciadeblas2bf767a2021-05-19 10:54:46 +020019DEVOPS_PATH=/usr/share/osm-devops
garciadeblas93c61312016-09-28 15:12:48 +020020
garciadeblas38d91ee2019-11-07 16:31:23 +010021function usage(){
22 echo -e "usage: $0 [OPTIONS]"
garciadeblas81077ae2023-07-03 19:31:15 +020023 echo -e "Install OSM"
garciadeblas38d91ee2019-11-07 16:31:23 +010024 echo -e " OPTIONS"
garciadeblas7f1e1042020-11-30 14:07:03 +000025 echo -e " -h / --help: print this help"
26 echo -e " -y: do not prompt for confirmation, assumes yes"
garciadeblas38d91ee2019-11-07 16:31:23 +010027 echo -e " -r <repo>: use specified repository name for osm packages"
garciadeblas5ea85ff2025-06-17 12:56:54 +020028 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
garciadeblas38d91ee2019-11-07 16:31:23 +010029 echo -e " -u <repo base>: use specified repository url for osm packages"
30 echo -e " -k <repo key>: use specified repository public key url"
garciadeblas96155042022-06-22 16:26:22 +020031 echo -e " -a <apt proxy url>: use this apt proxy url when downloading apt packages (air-gapped installation)"
garciadeblas8d8cd992024-05-21 16:04:14 +020032 echo -e " -c <kubernetes engine>: use a specific kubernetes engine (options: kubeadm, k3s), default is kubeadm"
33 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
34 echo -e " -M <KUBECONFIG_FILE>: Kubeconfig of an existing cluster to be used as mgmt cluster instead of OSM cluster"
35 echo -e " -G <KUBECONFIG_FILE>: Kubeconfig of an existing cluster to be used as auxiliary cluster instead of OSM cluster"
36 echo -e " --no-mgmt-cluster: Do not provision a mgmt cluster for cloud-native gitops operations in OSM (NEW in Release SIXTEEN) (by default, it is installed)"
37 echo -e " --no-aux-cluster: Do not provision an auxiliary cluster for cloud-native gitops operations in OSM (NEW in Release SIXTEEN) (by default, it is installed)"
38 echo -e " -D <devops path>: use local devops installation path"
garciadeblas81077ae2023-07-03 19:31:15 +020039 echo -e " -s <namespace> namespace when installed using k8s, default is osm"
garciadeblas5ea85ff2025-06-17 12:56:54 +020040 echo -e " -H <VCA host> use specific juju host controller IP"
41 echo -e " -S <VCA secret> use VCA/juju secret key"
42 echo -e " -P <VCA pubkey> use VCA/juju public key file"
43 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
garciadeblas8d8cd992024-05-21 16:04:14 +020044 echo -e " -w <work dir>: Location to store runtime installation"
garciadeblas5ea85ff2025-06-17 12:56:54 +020045 echo -e " -l: LXD cloud yaml file"
46 echo -e " -L: LXD credentials yaml file"
David Garcia404ae122020-04-28 11:47:55 +020047 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
garciadeblas7f1e1042020-11-30 14:07:03 +000048 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
49 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
garciadeblas9a510862021-04-21 14:15:56 +020050 echo -e " -T <docker tag> specify docker tag for the modules specified with option -m"
garciadeblas96155042022-06-22 16:26:22 +020051 echo -e " --debug: debug mode"
garciadeblas5ea85ff2025-06-17 12:56:54 +020052 echo -e " --nocachelxdimages: do not cache local lxd images, do not create cronjob for that cache (will save installation time, might affect instantiation time)"
53 echo -e " --cachelxdimages: cache local lxd images, create cronjob for that cache (will make installation longer)"
54 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
garciadeblas38d91ee2019-11-07 16:31:23 +010055 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
garciadeblas5ea85ff2025-06-17 12:56:54 +020056 echo -e " --nojuju: do not juju, assumes already installed"
57 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
garciadeblas38d91ee2019-11-07 16:31:23 +010058 echo -e " --nohostclient: do not install the osmclient"
59 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
garciadeblascb129372020-11-14 23:06:42 +000060 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
garciadeblas38d91ee2019-11-07 16:31:23 +010061 echo -e " --showopts: print chosen options and exit (only for debugging)"
garciadeblas5ea85ff2025-06-17 12:56:54 +020062 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
63 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
64 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
65 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
66 echo -e " [--small-profile]: Do not install and configure LXD which aims to use only K8s Clouds (--charmed option)"
67 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
68 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
69 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
70 echo -e " [--overlay]: Add an overlay to override some defaults of the default bundle (--charmed option)"
71 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
72 echo -e " [--tag]: Docker image tag. (--charmed option)"
73 echo -e " [--registry]: Docker registry with optional credentials as user:pass@hostname:port (--charmed option)"
garciadeblas38d91ee2019-11-07 16:31:23 +010074}
75
garciadeblasd8bc5c32018-05-09 17:37:56 +020076add_repo() {
77 REPO_CHECK="^$1"
78 grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1
79 if [ $? -ne 0 ]
80 then
garciadeblasbd925e42018-06-14 14:32:12 +020081 need_packages_lw="software-properties-common apt-transport-https"
garciadeblas0bc87522021-10-20 22:16:17 +020082 echo -e "Checking required packages to add ETSI OSM debian repo: $need_packages_lw"
garciadeblasbd925e42018-06-14 14:32:12 +020083 dpkg -l $need_packages_lw &>/dev/null \
84 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
garciadeblas5f420b12022-02-10 01:43:59 +010085 || sudo apt-get -qy update \
Mike Marchetti34124182018-10-16 08:22:30 -040086 || ! echo "failed to run apt-get update" \
garciadeblasbd925e42018-06-14 14:32:12 +020087 || exit 1
88 dpkg -l $need_packages_lw &>/dev/null \
89 || ! echo -e "Installing $need_packages_lw requires root privileges." \
90 || sudo apt-get install -y $need_packages_lw \
Mike Marchetti34124182018-10-16 08:22:30 -040091 || ! echo "failed to install $need_packages_lw" \
garciadeblasbd925e42018-06-14 14:32:12 +020092 || exit 1
garciadeblasbc97a012022-04-21 00:29:02 +020093 wget -q -O OSM-ETSI-Release-key.gpg "$REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg"
94 sudo APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=1 apt-key add OSM-ETSI-Release-key.gpg \
95 || ! echo -e "Could not add GPG key $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg" \
96 || exit 1
garciadeblas5f420b12022-02-10 01:43:59 +010097 sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1"
garciadeblasbc97a012022-04-21 00:29:02 +020098 sudo DEBIAN_FRONTEND=noninteractive apt-get -y update
garciadeblas429b9f82018-03-20 02:09:44 +010099 return 0
garciadeblasd8bc5c32018-05-09 17:37:56 +0200100 fi
101
102 return 1
garciadeblas55490d42016-10-29 14:22:03 +0200103}
104
garciadeblas25e87d22020-01-31 14:27:29 +0100105clean_old_repo() {
madaviae0784f2020-01-22 16:29:19 +0530106dpkg -s 'osm-devops' &> /dev/null
madaviae0784f2020-01-22 16:29:19 +0530107if [ $? -eq 0 ]; then
madaviae0784f2020-01-22 16:29:19 +0530108 # Clean the previous repos that might exist
109 sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list
110fi
111}
112
garciadeblas0bc87522021-10-20 22:16:17 +0200113function configure_apt_proxy() {
114 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
115 OSM_APT_PROXY=$1
116 OSM_APT_PROXY_FILE="/etc/apt/apt.conf.d/osm-apt"
117 echo "Configuring apt proxy in file ${OSM_APT_PROXY_FILE}"
118 if [ ! -f ${OSM_APT_PROXY_FILE} ]; then
119 sudo bash -c "cat <<EOF > ${OSM_APT_PROXY}
120Acquire::http { Proxy \"${OSM_APT_PROXY}\"; }
121EOF"
122 else
123 sudo sed -i "s|Proxy.*|Proxy \"${OSM_APT_PROXY}\"; }|" ${OSM_APT_PROXY_FILE}
124 fi
garciadeblas5f420b12022-02-10 01:43:59 +0100125 sudo apt-get -y update || FATAL "Configured apt proxy, but couldn't run 'apt-get update'. Check ${OSM_APT_PROXY_FILE}"
garciadeblas0bc87522021-10-20 22:16:17 +0200126 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
127}
128
garciadeblas5ea85ff2025-06-17 12:56:54 +0200129while getopts ":a:c:e:r:n:k:u:R:D:o:O:N:H:S:s:t:U:P:A:l:L:K:d:p:T:f:F:G:M:-: hy" o; do
garciadeblas8d8cd992024-05-21 16:04:14 +0200130
garciadeblas38d91ee2019-11-07 16:31:23 +0100131 case "${o}" in
Antonio Marsico75a38c72020-12-21 17:29:42 +0100132 D)
133 DEVOPS_PATH="${OPTARG}"
134 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100135 r)
136 REPOSITORY="${OPTARG}"
137 ;;
138 R)
139 RELEASE="${OPTARG}"
140 ;;
141 u)
142 REPOSITORY_BASE="${OPTARG}"
143 ;;
144 t)
garciadeblas25e87d22020-01-31 14:27:29 +0100145 DOCKER_TAG="${OPTARG}"
garciadeblas38d91ee2019-11-07 16:31:23 +0100146 ;;
garciadeblas72399e32019-11-22 10:09:40 +0100147 -)
148 [ "${OPTARG}" == "help" ] && usage && exit 0
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +0100149 ;;
garciadeblas25e87d22020-01-31 14:27:29 +0100150 :)
151 echo "Option -$OPTARG requires an argument" >&2
152 usage && exit 1
153 ;;
154 \?)
155 echo -e "Invalid option: '-$OPTARG'\n" >&2
156 usage && exit 1
157 ;;
158 h)
159 usage && exit 0
160 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100161 *)
162 ;;
163 esac
164done
165
garciadeblas25e87d22020-01-31 14:27:29 +0100166clean_old_repo
garciadeblasd8bc5c32018-05-09 17:37:56 +0200167add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops"
garciadeblas5f420b12022-02-10 01:43:59 +0100168sudo DEBIAN_FRONTEND=noninteractive apt-get -qy update
169sudo DEBIAN_FRONTEND=noninteractive apt-get -y install osm-devops
Antonio Marsico75a38c72020-12-21 17:29:42 +0100170$DEVOPS_PATH/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $DEVOPS_PATH -t $DOCKER_TAG "$@"